package com.bizofficer.admin.login;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepAdministrator;
import com.bizofficer.module.util.RoleModules;
import com.bizofficer.system.util.General;



@Service
public class LoginAdminService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	public Object execute(Object obj) throws NotFoundException{
		LoginAdminBean objBean = (LoginAdminBean) obj; 	
		LoginAdminResponseBean loginResponseBeanObj = new LoginAdminResponseBean();
		
		try {
			loginResponseBeanObj.setResponseTxt("failed");
			
			if(objBean.getUserId()==null || objBean.getUserId()==null) {
				return loginResponseBeanObj;
			}

			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			General gen = new General();
			
			TypedQuery<PgprepAdministrator> queryTeach = (TypedQuery<PgprepAdministrator>) entityManager.createQuery("from "+PgprepAdministrator.class.getName()+" where emailId=:emailId AND password=:password AND status=1 ", PgprepAdministrator.class);
			queryTeach.setParameter("emailId", objBean.getUserId());
			queryTeach.setParameter("password", gen.getMD5Hashing(objBean.getPassword()));
			List<?> resultListTeach = queryTeach.getResultList();
			Iterator<?> iteratorTeach=resultListTeach.iterator();
			if(iteratorTeach.hasNext()){
				PgprepAdministrator myObj = (PgprepAdministrator)iteratorTeach.next();
			
				loginResponseBeanObj.setEmailId(myObj.getEmailId());
            	loginResponseBeanObj.setFullName(myObj.getFullName());
           		loginResponseBeanObj.setUserType(myObj.getUserType());
            	
                loginResponseBeanObj.setToken(UUID.randomUUID().toString()+UUID.randomUUID().toString());
                
				if(myObj.getId()!=null && myObj.getId()>0) {
					PgprepAdministrator ssaveObj = (PgprepAdministrator)entityManager.find(PgprepAdministrator.class ,myObj.getId());
					ssaveObj.setLoginToken(loginResponseBeanObj.getToken());
					entityManager.getTransaction().commit();
				}
				
				if(myObj.getUserType()==0 && myObj.getRoleId()!=null && myObj.getRoleId()>0) {
						if(myObj.getPrivileges()!=null && myObj.getPrivileges().length()>0) {
							List<NavigationBean> navigationList = new ArrayList<NavigationBean>();	
							NavigationBean naviObj = new NavigationBean();
							
							for (Map.Entry<String, String> myMap : RoleModules.getMapmodules().entrySet()) {
								if(myObj.getPrivileges().indexOf("#"+myMap.getValue()+"@")>-1 ) {
									naviObj = new NavigationBean();
									naviObj.setUrl(myMap.getKey());
									naviObj.setLabel(myMap.getValue().replaceAll("_", " "));
									navigationList.add(naviObj);
								}
							    
							}
							loginResponseBeanObj.setNavigation(navigationList);
							loginResponseBeanObj.setRedirectUrl(navigationList.get(0).getUrl());
						}
						
				}else { /// FOR ADMIN ************************************

						List<NavigationBean> navigationList = new ArrayList<NavigationBean>();	
						NavigationBean naviObj = new NavigationBean();
						for (Map.Entry<String, String> myMap : RoleModules.getMapmodules().entrySet()) {
								naviObj = new NavigationBean();
								naviObj.setUrl(myMap.getKey());
								naviObj.setLabel(myMap.getValue().replaceAll("_", " "));
								navigationList.add(naviObj);
						}
						loginResponseBeanObj.setNavigation(navigationList);
						loginResponseBeanObj.setRedirectUrl("students");
				}
				
				
                loginResponseBeanObj.setResponseTxt("OK");
				System.out.println("**************************************************************");
				System.out.println("LoginAdminService successfully Admin Login Id: "+objBean.getUserId());
				System.out.println("**************************************************************");
                
			}	

			System.out.println("LoginAdminService UserId: "+objBean.getUserId() );
			
			
            entityManager.getTransaction().commit();
			entityManager.close();

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return loginResponseBeanObj;
	}
	
	
	
	
}
