package com.bizofficer.apiweb.forgotpassword;



import javax.sql.DataSource;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.module.util.MysqlTableNames;
import com.bizofficer.system.util.General;
import com.bizofficer.system.util.SendGridMail;

import java.io.FileReader;
import java.net.URL;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.UUID;


@Service
public class FPService{
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
	
	public Object execute(Object obj) throws NotFoundException{
		FPBean objBean = (FPBean) obj; 	
		FPResponseBean loginResponseBeanObj = new FPResponseBean();
		
		try {
			loginResponseBeanObj.setResponseTxt("failed");
			
			if(objBean.getUserId()==null) {
				return loginResponseBeanObj;
			}

			System.out.println("Forgot Password Service UserId: "+objBean.getUserId() );
			
	            this.conn = this.appDataSource.getConnection();
	            if (this.conn != null) {
	                this.ps = this.conn.prepareStatement("SELECT email_id FROM "+MysqlTableNames.getPgprepStudentDetails()+" WHERE student_id=? AND account_status=1");
	                this.ps.setString(1, objBean.getUserId());
	                System.out.println("Forgot Password Service query: " + this.ps);
	                this.rs = this.ps.executeQuery();
	                if (this.rs.next()) {
	
	                	String resetPasswordCode = UUID.randomUUID().toString().replaceAll("-", "");
	                	
	                	PreparedStatement psA = conn.prepareStatement("UPDATE "+MysqlTableNames.getPgprepStudentDetails()+" SET reset_pwd_code='"+resetPasswordCode+"' WHERE student_id='"+objBean.getUserId()+"' AND account_status=1 ");
	                    psA.executeUpdate();
	                    
	                    ///objBean.setEmailId("xxxxxxxxxx@gmail.com");
	                    
	                    General gen = new General();
	                    SendGridMail mailObj = new SendGridMail();				
						String[] emailsToArr = {rs.getString("email_id")};
						
						URL url = this.getClass().getResource("/resetpassword-email.json");
						String absoluteDiskPath = url.getPath();
						JSONParser jsonParser = new JSONParser();
						FileReader reader = new FileReader(absoluteDiskPath);
						Object objJson = jsonParser.parse(reader);	
						JSONObject json = (JSONObject) objJson;
						String subject = (String) json.get("subject")+"........."+gen.getRandomNumber(99, 9999);
						String messageBody = (String) json.get("message");
						
						//System.out.println("subject >>>> " + subject);
						//System.out.println("messageBody >>>> " + messageBody);
						
						messageBody = messageBody.replace("[TOKEN]", resetPasswordCode );
								
						System.out.println("Mail Status: " + mailObj.send(emailsToArr, null, subject, messageBody));
	                	
	                    loginResponseBeanObj.setResponseTxt("OK");
	                    
	                    if(rs.getString("email_id")!=null && rs.getString("email_id").indexOf("@")>-1) {
	                    	loginResponseBeanObj.setEmailId(rs.getString("email_id").replaceAll("\\S{1,5}@","*****@"));
	                    }
	                    
	    				System.out.println("**************************************************************");
	    				System.out.println("Token: "+resetPasswordCode);
	    				System.out.println("Successfully Forgot Password Service EmailId: "+rs.getString("email_id"));
	    				System.out.println("**************************************************************");
	                    
	                }else {
	                	loginResponseBeanObj.setResponseTxt("InvalidUserId");
	                }
	                
	                this.rs.close();
	                this.ps.close();
	                this.conn.close();
            }

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return loginResponseBeanObj;
	}
	
	
	
	
}
