package com.bizofficer.apiweb.forgotpassword;



import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.module.util.MysqlTableNames;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;


@Service
public class VerifyFPOtpService{
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
	
	public Object execute(Object obj) throws NotFoundException{
		FPBean objBean = (FPBean) obj; 	
		FPResponseBean loginResponseBeanObj = new FPResponseBean();
		
		try {
			loginResponseBeanObj.setResponseTxt("failed");
			
			if(objBean.getResetPasswordToken()==null || objBean.getOtpNumber()==null) {
				return loginResponseBeanObj;
			}

			System.out.println("VerifyFPOtpService ResetPasswordToken: "+objBean.getResetPasswordToken() );
			System.out.println("VerifyFPOtpService OtpNumber: "+objBean.getOtpNumber() );
			
	            this.conn = this.appDataSource.getConnection();
	            if (this.conn != null) {
	                this.ps = this.conn.prepareStatement("SELECT 1 FROM "+MysqlTableNames.getPgprepStudentDetails()+" WHERE reset_pwd_code=? AND otp=? AND account_status=1");
	                this.ps.setString(1, objBean.getResetPasswordToken());
	                this.ps.setInt(2, objBean.getOtpNumber());
	                System.out.println("VerifyFPOtpService query: " + this.ps);
	                this.rs = this.ps.executeQuery();
	                if (this.rs.next()) {
	
	                    loginResponseBeanObj.setResponseTxt("OK");
	                    
	    				System.out.println("**************************************************************");
	    				System.out.println("Successfully Verify OTP");
	    				System.out.println("**************************************************************");
	                    
	                }else {
	                	loginResponseBeanObj.setResponseTxt("InvalidOTP");
	                }
	                
	                this.rs.close();
	                this.ps.close();
	                this.conn.close();
            }

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return loginResponseBeanObj;
	}
	
	
	
	
}
