package com.bizofficer.apiweb.keywords;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;
import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.AssessmentTreeview;
import com.bizofficer.hibernate.repository.TopicKeywordRepository;
import com.bizofficer.module.util.MysqlTableNames;



@Service
public class KeywordService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	TopicKeywordRepository topicKeywordRepoObj;
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
	
	public List<?> doExecute(Object obj) throws NotFoundException{
		KeywordBean objBean = (KeywordBean) obj; 	
		List<CoursesKeywordBean> dataList = new ArrayList<CoursesKeywordBean>();
		
		try {
		
			///String WhereQry=" and topicId IN (1000,1001,1002,1003) ";
			String WhereQry="";
			if(objBean.getTemplateId()!=null) {
				List<Integer> templateTopics = this.getTopicIds(objBean.getTemplateId());
				if(templateTopics.size()>0) {
					WhereQry=" and a.topic_id IN ("+templateTopics.toString().substring(1,templateTopics.toString().length()-1)+") ";
				}				
			}

			CoursesKeywordBean beanObj;
			List <String> keywordList = new ArrayList<String>();
        	conn = appDataSource.getConnection();
            if(conn != null)
            {
                ps = conn.prepareStatement("SELECT a.keyword_id,a.keyword,b.count1 FROM "+MysqlTableNames.getTopicKeyword()+" a LEFT JOIN "+MysqlTableNames.getQbKeyword()+" b ON a.keyword=b.keyword_name WHERE a.status='Active' and a.keyword is not null and LENGTH(a.keyword)>0 "+WhereQry+" GROUP BY a.keyword ORDER BY a.keyword asc ");
                System.out.println("topic main query: "+ps);
                rs = ps.executeQuery();
    			if(rs!=null) {
	                while(rs.next())
	                {
						if(keywordList.indexOf(rs.getString("keyword").toUpperCase())==-1) {
							beanObj = new CoursesKeywordBean();
							beanObj.setId(rs.getInt("keyword_id"));
							beanObj.setTitle(rs.getString("keyword").toUpperCase());
							beanObj.setQuestionCount(rs.getInt("count1"));
							keywordList.add(rs.getString("keyword").toUpperCase());
							dataList.add(beanObj);
						}
	                	
	                }
    			}else {
    				beanObj = new CoursesKeywordBean();
    				beanObj.setId(0);
    				beanObj.setTitle("Keyword Not Found");				
    				dataList.add(beanObj);
    			}

	            rs.close();
                ps.close();
                
            }
            conn.close();
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		////System.out.println( "dataList >>> " +  dataList );
			
		return dataList;
	}
	

	
	public List<Integer> getTopicIds(Integer templateId)
    {
        List<Integer> topicList = new ArrayList<Integer>();
        
        try{
        	
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
        	
        	conn = appDataSource.getConnection();
            if(conn != null)
            {
                ps = conn.prepareStatement("SELECT a.* FROM "+MysqlTableNames.getPgprepAssessmentTreeview()+" a LEFT JOIN "+MysqlTableNames.getTemplateAssessmentTreeview()+" b ON a.childnode_id=b.childnode_id WHERE b.template_id=? AND b.status='Active' AND a.parentnode_name=?");
                ps.setInt(1, templateId);
                ps.setString(2, "");
                System.out.println("topic main query: "+ps);
                rs = ps.executeQuery();
                while(rs.next())
                {
                	if(rs.getInt("childnode_id")>0) {
    					if(topicList.indexOf(rs.getInt("childnode_id"))==-1) {
    						topicList.add(rs.getInt("childnode_id"));
    						
    						TypedQuery<AssessmentTreeview> queryCheckSubTopic1 = (TypedQuery<AssessmentTreeview>) entityManager.createQuery("from "+AssessmentTreeview.class.getName()+" where status='Active' and parentnodeName=:childnodeName ", AssessmentTreeview.class);
    						queryCheckSubTopic1.setParameter("childnodeName", rs.getString("childnode_name"));
    						queryCheckSubTopic1.setFirstResult(0);
    						queryCheckSubTopic1.setMaxResults(1);
    						List<?> resultListCheckSubTopic1 = queryCheckSubTopic1.getResultList();
    						Iterator<?> iteratorCheckSubTopic1=resultListCheckSubTopic1.iterator();
    						if(iteratorCheckSubTopic1.hasNext()){
    							//****************************************************************
    							topicList = this.subTopicsList(entityManager, topicList, rs.getString("childnode_name"));
    							//****************************************************************
    						} // close if(myObj
    						
    					}
    				}
                }
                rs.close();
                ps.close();
                conn.close();
            }
        	
			System.out.println( "KeywordService topicList >>>> " + topicList);
			
			entityManager.getTransaction().commit();
			entityManager.close();
			
  	    }catch(Exception ex){
    	   ex.printStackTrace();
   	    }

        
        return topicList;
        
  }


	private List<Integer> subTopicsList(EntityManager entityManager, List<Integer> topicList, String topicName) {
		
		TypedQuery<AssessmentTreeview> query = (TypedQuery<AssessmentTreeview>) entityManager.createQuery("from "+AssessmentTreeview.class.getName()+" where status='Active' and parentnodeName='"+topicName+"'  ", AssessmentTreeview.class);
		List<?> resultList = query.getResultList();
		Iterator<?> iterator=resultList.iterator();
		while(iterator.hasNext()){
			AssessmentTreeview myObj = (AssessmentTreeview)iterator.next();				
			
			topicList.add(myObj.getChildnodeId());
			
			TypedQuery<AssessmentTreeview> queryCheckSubTopic1 = (TypedQuery<AssessmentTreeview>) entityManager.createQuery("from "+AssessmentTreeview.class.getName()+" where status='Active' and parentnodeName='"+myObj.getChildnodeName()+"' ", AssessmentTreeview.class);
			queryCheckSubTopic1.setFirstResult(0);
			queryCheckSubTopic1.setMaxResults(1);
			List<?> resultListCheckSubTopic1 = queryCheckSubTopic1.getResultList();
			Iterator<?> iteratorCheckSubTopic1=resultListCheckSubTopic1.iterator();
			if(iteratorCheckSubTopic1.hasNext()){
				//****************************************************************
			    
				this.subTopicsList(entityManager, topicList, myObj.getChildnodeName());
				
				//****************************************************************
			} // close if(myObj
			
		} // close while(iterator
		
		return topicList;

	} // makeTree Method close

	
	
	
	
	
	
	
}
