package com.bizofficer.apiweb.liveclass;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Service
public class LiveClassController {
	
	@Autowired
	private LiveClassService cclsObj;

	@Value("${rowsInPage}")
	private Integer rowsInPage;
	
	@RequestMapping(value = {"/myliveclasses"}, method = RequestMethod.GET)
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")BeanLiveClass objBean) {
		
		try {
			
			LiveClassRespBeans respObj = (LiveClassRespBeans) (Object) cclsObj.doExecute(objBean);
			
			System.out.println( "ResponseTxt >>> " +  respObj.getResponseTxt() );
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(respObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
