package com.bizofficer.apiweb.login;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.UUID;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;
import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepStudentCourses;
import com.bizofficer.hibernate.entity.PgprepStudentDetails;
import com.bizofficer.hibernate.entity.SubscriptionCourses;
import com.bizofficer.hibernate.repository.PgprepStudentCoursesRepository;
import com.bizofficer.module.util.MysqlTableNames;
import com.bizofficer.system.util.General;
import com.bizofficer.system.util.MakeDate;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;


@Service
public class LoginMultiOrgService{
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
    
    @Autowired
	EntityManagerFactory entityManagerFactory;
    
    @Autowired
    PgprepStudentCoursesRepository pscRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		LoginBean objBean = (LoginBean) obj; 	
		LoginResponseBean loginResponseBeanObj = new LoginResponseBean();
		
		try {
			loginResponseBeanObj.setResponseTxt("failed");

			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			if(objBean.getPassword()!=null && objBean.getPassword().length()>0) {
				General gen = new General();
				objBean.setPassword(gen.getMD5Hashing(objBean.getPassword()));
			}
			
			if(objBean.getLoginKey()!=null && objBean.getLoginKey().length()>0 && objBean.getUserId()==null && objBean.getPassword()==null) {
				System.out.println("LoginService Login Key: "+objBean.getLoginKey() );
				TypedQuery<PgprepStudentDetails> query = (TypedQuery<PgprepStudentDetails>) entityManager.createQuery("from "+PgprepStudentDetails.class.getName()+" where loginKey=:loginKey ", PgprepStudentDetails.class);
				query.setParameter("loginKey", objBean.getLoginKey() );
				query.setFirstResult(0);
				query.setMaxResults(1);
				List<?> resultList = query.getResultList();
				Iterator<?> iterator=resultList.iterator();
				if(iterator.hasNext()){
					PgprepStudentDetails myObj = (PgprepStudentDetails)iterator.next();
					System.out.println("LoginService StudentId: "+myObj.getStudentId() );
					objBean.setUserId(myObj.getStudentId());
					objBean.setPassword(myObj.getPassword());
				}	
			}
			
			System.out.println("A LoginService UserId: "+objBean.getUserId() );
			
			if(objBean.getUserId()==null || objBean.getPassword()==null) {
				return loginResponseBeanObj;
			}
			
        	//SimpleDateFormat dtformat = new SimpleDateFormat("yyyy-MM-dd");
            //String today = dtformat.format(new Date());
			
			System.out.println("B LoginService UserId: "+objBean.getUserId() );
			
            this.conn = this.appDataSource.getConnection();
            if (this.conn != null && objBean.getUserId()!=null && objBean.getPassword()!=null) {
            	
                this.ps = this.conn.prepareStatement("SELECT * FROM "+MysqlTableNames.getPgprepStudentDetails()+" WHERE (student_id=? OR email_id=? OR phone_no=?) AND password=? AND account_status=1");
                this.ps.setString(1, objBean.getUserId());
                this.ps.setString(2, objBean.getUserId());
                this.ps.setString(3, objBean.getUserId());
                this.ps.setString(4, objBean.getPassword());
                System.out.println("LoginService query: " + this.ps);
                this.rs = this.ps.executeQuery();
                if (this.rs.next()) {

                	System.out.println("LoginService query executed ID: " + rs.getInt("id"));
                    	
                	    loginResponseBeanObj.setSid(rs.getInt("id"));
                    	loginResponseBeanObj.setStudentId(rs.getString("student_id"));
                    	loginResponseBeanObj.setEmailId(rs.getString("email_id"));
                        loginResponseBeanObj.setProfilePic(rs.getString("photo"));
                        loginResponseBeanObj.setStudentName(rs.getString("sname"));
                        loginResponseBeanObj.setToken(UUID.randomUUID().toString()+UUID.randomUUID().toString());
                        loginResponseBeanObj.setPhoneNo(rs.getString("phone_no"));
                        loginResponseBeanObj.setOpenedCourse(rs.getInt("openedCourse"));

                        if(rs.getInt("account_status")>0) {
                        	loginResponseBeanObj.setStatus("Active");
        				}else {
        					loginResponseBeanObj.setStatus("Inactive");
        				}
                        
                        PreparedStatement psA = conn.prepareStatement("UPDATE "+MysqlTableNames.getPgprepStudentDetails()+" SET token='"+loginResponseBeanObj.getToken()+"' WHERE student_id='"+loginResponseBeanObj.getStudentId()+"' ");
                        psA.executeUpdate();

                        OrganisationBean orgBeanObj = new OrganisationBean();
                        List<OrganisationBean> organisationList = new ArrayList<OrganisationBean>();
                        
                        PreparedStatement stmtA = conn.prepareStatement("SELECT m.*, ot.template_id, s.validTillDate, s.courseTitle, s.courseId, s.subscriptionType, s.id as validityId FROM "+MysqlTableNames.getPgprepStudentCourses()+" s, "+MysqlTableNames.getOrganisationTemplateAssociation()+" ot, "+MysqlTableNames.getPgprepOrganisationMenu()+" m WHERE s.organisationId = ot.organisation_id AND s.organisationId = m.organisationId AND s.studentId=? group by s.organisationId order by s.id ");
                        stmtA.setString(1, rs.getString("student_id"));
                        System.out.println("LoginService AAA: " + stmtA);
                        ResultSet myRow = stmtA.executeQuery();
                        if(myRow.isBeforeFirst()) {
                        	System.out.println("MULTI ORGANISATION ASSOCIATIONS FOUND");
	                        while (myRow.next()) {
	                        	orgBeanObj = new OrganisationBean();
	                        	
	                        	orgBeanObj.setValidityId(myRow.getInt("validityId"));
	                        	orgBeanObj.setCourseId(myRow.getInt("courseId"));
	                        	orgBeanObj.setOrganisationId(myRow.getInt("organisationId"));
	                        	orgBeanObj.setOrganisationName(myRow.getString("courseTitle"));
	                        	orgBeanObj.setTemplateId(myRow.getInt("template_id"));
	                        	orgBeanObj.setValidTillDate(myRow.getString("validTillDate"));
	                        	orgBeanObj.setSubscriptionType(myRow.getString("subscriptionType"));
	                        	
	                        	orgBeanObj.setDashboard(myRow.getInt("dashboard"));
	                        	orgBeanObj.setReport(myRow.getInt("report"));
	                        	orgBeanObj.setSmartLearning(myRow.getInt("smartLearning"));
	                        	orgBeanObj.setSelfTest(myRow.getInt("selfTest"));
	                        	orgBeanObj.setTopicTest(myRow.getInt("topicTest")); 
	                        	orgBeanObj.setMockTest(myRow.getInt("mockTest")); 
	                        	orgBeanObj.setClassTest(myRow.getInt("classTest"));
	                        	orgBeanObj.setTeacherHelp(myRow.getInt("teacherHelp"));
	                        	
	                        	organisationList.add(orgBeanObj);
	                        }
	                        
	                    ////*****************************************************    
                        }else if(rs.getInt("organisation_id")>0) {
                        	
                        	System.out.println("SINGLE ORGANISATION LOGIN");
                        	
                        	TypedQuery<SubscriptionCourses> querySC = (TypedQuery<SubscriptionCourses>) entityManager.createQuery("from "+SubscriptionCourses.class.getName()+" where websiteId=1 AND (freeOrganisationId=:organisationId OR paidOrganisationId=:organisationId) ", SubscriptionCourses.class);
                        	querySC.setParameter("organisationId", rs.getInt("organisation_id"));
                        	querySC.setFirstResult(0);
                        	querySC.setMaxResults(1);
            				List<?> resultSC = querySC.getResultList();
            				Iterator<?> iteratorSC = resultSC.iterator();
            				if(iteratorSC.hasNext()){
            					SubscriptionCourses mySC = (SubscriptionCourses)iteratorSC.next();
            					
            					System.out.println("ORGANISATION FOUND");
	                        	
	                        	///ADD COURSE TO STUDENT ************************************** START
	                			///FREE FOREVER COURSE *********************************************
	                        	MakeDate dateObj = new MakeDate();
            					PgprepStudentCourses corsObjF = new PgprepStudentCourses();
	                			corsObjF.setSid(rs.getInt("id"));
	                			corsObjF.setCourseId(77);
	                			corsObjF.setCourseTitle("FREE FOREVER");
	                			corsObjF.setOrganisationId(4);
	                			corsObjF.setStudentId(rs.getString("student_id"));	                			
	                			if(rs.getString("registration_valid_till")!=null) {
	                				corsObjF.setValidTillDate(dateObj.getAfterDaysDate(1000, "yyyy-MM-dd"));
	    						}
	                			corsObjF.setSubscriptionType("FREE");			
	                			pscRepo.save(corsObjF);
	                        	//---------------------------------------------------------
	                			if(rs.getInt("organisation_id")>0 && rs.getInt("organisation_id")!=4) {
		                        	PgprepStudentCourses saveObj = new PgprepStudentCourses();
		    						saveObj.setSid(rs.getInt("id"));
		    						saveObj.setCourseId(mySC.getCourseId());
		    						saveObj.setCourseTitle(mySC.getCourseTitle());					
		    						saveObj.setStudentId(rs.getString("student_id"));
		    						if(rs.getString("account_type") != null && "PAID".equalsIgnoreCase(rs.getString("account_type")) ) {
		    							saveObj.setSubscriptionType("PAID");
		                        	}else {
		                        		saveObj.setSubscriptionType("FREE");
		                        	}		    							    						
		    						if(rs.getString("registration_valid_till")!=null) {
		    							saveObj.setValidTillDate(dateObj.getStringToDate(rs.getString("registration_valid_till"), "yyyy-MM-dd"));
		    						}
		    						saveObj.setOrganisationId(rs.getInt("organisation_id"));	    						
		    						pscRepo.save(saveObj);	    
	                			}
	    						//ADD COURSE TO STUDENT ************************************** END
	                        	
	                            PreparedStatement stmtBB = conn.prepareStatement("SELECT m.*, ot.template_id, s.validTillDate, s.courseTitle, s.courseId, s.subscriptionType, s.id as validityId FROM "+MysqlTableNames.getPgprepStudentCourses()+" s, "+MysqlTableNames.getOrganisationTemplateAssociation()+" ot, "+MysqlTableNames.getPgprepOrganisationMenu()+" m WHERE s.organisationId = ot.organisation_id AND s.organisationId = m.organisationId AND s.studentId=? group by s.organisationId order by s.id ");
	                            stmtBB.setString(1, rs.getString("student_id"));
	                            System.out.println("LoginService AAA: " + stmtBB);
	                            ResultSet myRowBB = stmtBB.executeQuery();
    	                        while (myRowBB.next()) {
	    	                        	orgBeanObj = new OrganisationBean();
	    	                        	
	    	                        	orgBeanObj.setValidityId(myRowBB.getInt("validityId"));
	    	                        	orgBeanObj.setCourseId(myRowBB.getInt("courseId"));
	    	                        	orgBeanObj.setOrganisationId(myRowBB.getInt("organisationId"));
	    	                        	orgBeanObj.setOrganisationName(myRowBB.getString("courseTitle"));
	    	                        	orgBeanObj.setTemplateId(myRowBB.getInt("template_id"));
	    	                        	orgBeanObj.setValidTillDate(myRowBB.getString("validTillDate"));
	    	                        	orgBeanObj.setSubscriptionType(myRowBB.getString("subscriptionType"));
	    	                        	
	    	                        	orgBeanObj.setDashboard(myRowBB.getInt("dashboard"));
	    	                        	orgBeanObj.setReport(myRowBB.getInt("report"));
	    	                        	orgBeanObj.setSmartLearning(myRowBB.getInt("smartLearning"));
	    	                        	orgBeanObj.setSelfTest(myRowBB.getInt("selfTest"));
	    	                        	orgBeanObj.setTopicTest(myRowBB.getInt("topicTest")); 
	    	                        	orgBeanObj.setMockTest(myRowBB.getInt("mockTest")); 
	    	                        	orgBeanObj.setClassTest(myRowBB.getInt("classTest"));
	    	                        	orgBeanObj.setTeacherHelp(myRowBB.getInt("teacherHelp"));
	    	                        	
	    	                        	organisationList.add(orgBeanObj);
    	                        }
	                        	
                            }	
                        	
                        }
                        
                        loginResponseBeanObj.setOrganisations(organisationList);
                        
                        if(rs.getInt("schoolId")>0) {
    						List<StudentSchoolBean> schools = new ArrayList<StudentSchoolBean>();
    						StudentSchoolBean schoolBeanObj;
    						
    						schoolBeanObj = new StudentSchoolBean();
    						schoolBeanObj.setSchoolId(rs.getInt("schoolId"));
    						schoolBeanObj.setSchoolName(rs.getString("schoolName"));
    						schoolBeanObj.setClassName(rs.getString("className"));
    						schoolBeanObj.setAdmissionNumber(rs.getString("admissionNumber"));
    						
    						schools.add(schoolBeanObj);

    						loginResponseBeanObj.setSchools(schools);	
                        }	

                        if(loginResponseBeanObj.getOrganisations()!=null && loginResponseBeanObj.getOrganisations().size()>0) {
                        	loginResponseBeanObj.setResponseTxt("OK");
        					System.out.println("**************************************************************");
        					System.out.println("Login successfully Student Id: "+objBean.getUserId());
        					System.out.println("**************************************************************");
        					
                        }else {
        					System.out.println("**************************************************************");
        					System.out.println("Login FAILED Student Id: "+objBean.getUserId());
        					System.out.println("**************************************************************");
                        	
                        }
                        
                        
                    
                }
                
                this.rs.close();
                this.ps.close();
                this.conn.close();
            }

            entityManager.getTransaction().commit();
			entityManager.close();
			
		}catch(Exception e) {
			e.getStackTrace();			
		}
		
		
		return loginResponseBeanObj;
	}
	
	
	
	
}
