package com.bizofficer.apiweb.mocktestlist;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.module.util.MysqlTableNames;



@Service
public class MockTestListService{
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
	
	public List<?> doExecute(Object obj) throws NotFoundException{
		BeanMT objBean = (BeanMT) obj; 	
		List<MockTestListBean> dataList = new ArrayList<MockTestListBean>();
		
		if(objBean.getTemplateId()==null ) {
			return dataList;
		}
		
		MockTestListBean mockTestBeanObj;
		List<TestListBean> testList = new ArrayList<TestListBean>();
		TestListBean testListBeanObj;
		List<SectionSetBean> sectionSetListObj = new ArrayList<SectionSetBean>();
		SectionSetBean sectionSetBeanObj;
		
		Double totalMarks = 0.0;

        try {

    		///******************************************************************
            String getFinalRoot = this.getMockFinalRoot(objBean.getTemplateId(), "");
            String[] finalrootArray = getFinalRoot.split("\\|");
            String cond = "";
            getFinalRoot = finalrootArray[0];
            int numRow = Integer.parseInt(finalrootArray[1]);
            if (numRow == 0) {
                cond = "mc.child_category";
            } else {
                cond = "mc.parent_category";
            }

            conn = appDataSource.getConnection();
            if (conn != null) {
            	
                ps = conn.prepareStatement("SELECT mc.category_id,mc.child_category FROM "+MysqlTableNames.getModeltestCategory()+" mc INNER JOIN "+MysqlTableNames.getTemplateModeltestCategory()+" tc ON mc.category_id = tc.category_id WHERE tc.status ='Active' AND tc.template_id = ? AND " + cond + " = ?", ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_READ_ONLY);
                ps.setInt(1, objBean.getTemplateId());
                ps.setString(2, getFinalRoot);
                System.out.println("mocktest category: "+this.ps);
                rs = ps.executeQuery();                
                while (rs.next()) {
                    
					mockTestBeanObj = new MockTestListBean();
					mockTestBeanObj.setCategoryId(rs.getInt(1));
					mockTestBeanObj.setCategoryName(rs.getString(2));
					
					testList = new ArrayList<TestListBean>();

                    
                    ps = conn.prepareStatement("SELECT mm.mocktest_generated_id,mm.model_test_id,mm.mocktest_generated_title FROM "+MysqlTableNames.getMocktestManagement()+" mm LEFT JOIN "+MysqlTableNames.getMocktestCategoryAssociation()+" mca ON mm.mocktest_id = mca.mocktest_id WHERE mca.category_id=?");
                    ps.setInt(1, rs.getInt(1));
                    ResultSet rs1 = ps.executeQuery();
                    while (rs1.next()) {
                        
						testListBeanObj = new TestListBean();
						
						testListBeanObj.setMocktestGeneratedId(rs1.getInt(1));
						testListBeanObj.setModelTestId(rs1.getInt(2));
						testListBeanObj.setTestName(rs1.getString(3));
						
						//Integer testTotalTime = 0;
						///Integer totalQuestions = 0;

						
						/*************************************************************
							SECTION MANAGEMENT
						***************************************************************/
							sectionSetListObj = new ArrayList<SectionSetBean>();
							int startNum = 1, endNum = 0;
							
			                ps = conn.prepareStatement("SELECT SUM(mq.no_of_question) AS totalQuestion, mm.duration,mm.section_allow,mm.marks_correct_ans,mm.marks_incorrect_ans,mm.marks_not_ans,mm1.mocktest_generated_title FROM "+MysqlTableNames.getMocktestQuestionAssociation()+" mq LEFT JOIN "+MysqlTableNames.getMocktestManagement()+" mm1 ON mq.mocktest_generated_id=mm1.mocktest_generated_id LEFT JOIN "+MysqlTableNames.getModelTestManagement() +" mm ON mm1.model_test_id=mm.model_test_id WHERE mq.mocktest_generated_id=? AND mm.model_test_id=?");
			                ps.setInt(1, rs1.getInt(1));
			                ps.setInt(2, rs1.getInt(2));
			                System.out.println("Fetching mock exam info query: " + ps);
			                ResultSet rs2 = ps.executeQuery();
			                if (rs2.next()) {
								testListBeanObj.setTotalQuestions(rs2.getInt(1));
								testListBeanObj.setTestTotalTime(rs2.getInt(2));								
								testListBeanObj.setCorrectAnsMark(rs2.getDouble(4));
								testListBeanObj.setWrongAnsMark(rs2.getDouble(5));
								testListBeanObj.setNoAnsMark(rs2.getDouble(6));
								
								if(rs2.getInt(1)>0 && rs2.getDouble(4)>0) {
									testListBeanObj.setTotalMarks(rs2.getInt(1)*rs2.getDouble(4));
								}
			                    
			                    if (rs2.getInt(3) == 1) {
			                        ///examDetails.setSectionAllow(true);
			                        ///List<MockTestSectionModel> sectionList = new ArrayList<>();
			                    	totalMarks = 0.0;
			                        ps = conn.prepareStatement("SELECT sm.section_id,sm.section_name,sm.no_question,sm.correct_marks,sm.incorrect_marks,sm.no_answer_marks,sm.section_time FROM "+MysqlTableNames.getSectionManagement()+" sm LEFT JOIN "+MysqlTableNames.getModelSectionManagement()+" ms ON sm.section_id=ms.section_id WHERE model_id=? ORDER BY sm.section_id");
			                        ps.setInt(1, rs1.getInt(2));
			                        System.out.println("Fetching mock section exam info query: " + ps);
			                        ResultSet rs3 = ps.executeQuery();
			                        while (rs3.next()) {
			                            
			                            sectionSetBeanObj = new SectionSetBean();
			                            sectionSetBeanObj.setSectionId(rs3.getInt(1));
										sectionSetBeanObj.setSectionName(rs3.getString(2));
										endNum+= rs3.getInt(3); //section number of question
										sectionSetBeanObj.setQuestionRange(startNum+"-"+endNum);
										sectionSetBeanObj.setTotalTime(rs3.getInt(7));
										sectionSetBeanObj.setCorrectMarks(rs3.getDouble(4));
										sectionSetBeanObj.setIncorrectMarks(rs3.getDouble(5));
										sectionSetBeanObj.setNotAnswerMarks(rs3.getDouble(6));
										sectionSetListObj.add(sectionSetBeanObj);
										
										startNum+= rs3.getInt(3);
										
										totalMarks += rs3.getInt(3)*rs3.getDouble(4);
										
			                        }
			                        
			                        rs3.close();
			                        
			                    } 
			                    
			                    if(totalMarks>0) {
			                    	testListBeanObj.setTotalMarks(totalMarks);
			                    }
			                    
			                }
			                
			                rs2.close();
							
			                
							testListBeanObj.setSectionSet(sectionSetListObj);
							testList.add(testListBeanObj);
							
							
						
                    }
                    
                    rs1.close();
                    
                    mockTestBeanObj.setTestList(testList);
					dataList.add(mockTestBeanObj);
					
                }
                rs.close();
                ps.close();
                conn.close();
            }
            
            
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
        return dataList;
    }
	
	
	
    private String getMockFinalRoot(int tempId, String rootNode) {
        String finalRoot = "";
        int numCategory = 0;
        try {
            conn = appDataSource.getConnection();
            if (conn != null) {
            	
                ps = conn.prepareStatement("SELECT mc.child_category FROM "+MysqlTableNames.getModeltestCategory()+" mc LEFT JOIN "+MysqlTableNames.getTemplateModeltestCategory()+" tm ON mc.category_id=tm.category_id WHERE tm.template_id=? AND tm.status='Active' AND mc.parent_category=? ");
                ps.setInt(1, tempId);
               	ps.setString(2, rootNode);
                ///System.out.println("find final root query: "+this.ps);
                
                rs = ps.executeQuery();
                finalRoot = rootNode;
                int rowNum=0;
                while (rs.next()) {
                	////System.out.println("child_category >>> " + rs.getString(1) );
                    rootNode = rs.getString(1);
                    rowNum++;
                }
                numCategory = rowNum;
                rs.close();
                ps.close();
                conn.close();
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }        
        
        if (numCategory == 1) {
            return getMockFinalRoot(tempId, rootNode);
        } else {        	
        	System.out.println(finalRoot + "|" + numCategory);        	
            return finalRoot + "|" + numCategory;
        }
        
    }

	

	
}
