package com.bizofficer.apiweb.testdetail;



import java.util.Iterator;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepTestSummary;
import com.bizofficer.hibernate.repository.PgprepTestDetailsRepository;
import com.bizofficer.hibernate.repository.PgprepTestSummaryRepository;



@Service
public class TestDetailExistingService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepTestDetailsRepository tdRepoObj;
	
	@Autowired
	PgprepTestSummaryRepository tsRepoObj;
	
	public Object execute(Object obj) throws NotFoundException{
		BeanTesting objBean = (BeanTesting) obj; 	
		
		try {
			
			if(objBean.getTestSession()==null || objBean.getOrganisationId()==null || objBean.getStudentId()==null) {
				return objBean;
			}
			
			System.out.println("TestDetailExistingService Test Id: "+objBean.getTestSession() );
			System.out.println("TestDetailExistingService Organisation Id: "+objBean.getOrganisationId() );
			System.out.println("TestDetailExistingService Student Id: "+objBean.getStudentId() );
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			TypedQuery<PgprepTestSummary> query = (TypedQuery<PgprepTestSummary>) entityManager.createQuery("from "+PgprepTestSummary.class.getName()+" where testStatus=0 and organisationId=:organisationId and studentId=:studentId and testSession=:testSession ", PgprepTestSummary.class);
			query.setParameter("organisationId", objBean.getOrganisationId());
			query.setParameter("studentId", objBean.getStudentId()); 
			query.setParameter("testSession", objBean.getTestSession());
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();	
			if(iteratorCat.hasNext()){
				PgprepTestSummary myObj = (PgprepTestSummary)iteratorCat.next();				
				objBean.setTestDetail(myObj.getTestDetail().substring(1, myObj.getTestDetail().length()-1));
			}
				
			entityManager.getTransaction().commit();
			entityManager.close();
				
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return objBean;
	}
	
	
	
	
}
