package com.bizofficer.configurations;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;
import org.springframework.jdbc.datasource.DriverManagerDataSource;

@Configuration
public class AppConfig {

	@Autowired
	private Environment env;	
	
    @Bean(name="appDataSource")
    public DataSource appDataSource()
    {
        DriverManagerDataSource dataSource = new DriverManagerDataSource();
        dataSource.setDriverClassName("com.mysql.cj.jdbc.Driver");

	     dataSource.setUrl(env.getProperty("dataSourceURL"));
	     dataSource.setUsername(env.getProperty("dataSourceUSERNAME"));
	     dataSource.setPassword(env.getProperty("dataSourcePASSWORD"));
		
        return dataSource;
    }
    
    // FOR MULTIPLE DATABASE CONECTIVITY
    /*
    @Bean
    @Primary
    @ConfigurationProperties(prefix="spring.datasource")
    public DataSource primaryDataSource() {
        return DataSourceBuilder.create().build();
    }

    @Bean
    @ConfigurationProperties(prefix="spring.secondDatasource")
    public DataSource secondaryDataSource() {
        return DataSourceBuilder.create().build();
    }
    */
    

}
