package com.bizofficer.hibernate.entity;

import java.util.Date;

import javax.persistence.Cacheable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;


@Entity
@Table(name = "pgprep_live_classes")
@Cacheable
public class PgprepLiveClasses {

	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
	private Integer id;

	@Column(name = "schoolId")	
	private Integer schoolId;
	
	@Column(name = "className")	
	private String className;
	
	@Column(name = "subject")	
	private String subject;
	
	@Column(name = "teacherId")	
	private Integer teacherId;
	
	@Column(name = "meetingNumber")	
	private String meetingNumber;
	
	@Column(name = "meetingPassword")	
	private String meetingPassword;
	
	@Column(name = "startTime")
	@Temporal(TemporalType.TIMESTAMP)
	private Date startTime;

	@Column(name = "duration")	
	private Integer duration;
	
	@Column(name = "sendNotification")	
	private Integer sendNotification;
	
	@Column(name = "note")	
	private String note;
	
	@Column(name = "status")	
	private Integer status;
	
	@Column(name = "createdDateTime")
	@Temporal(TemporalType.TIMESTAMP)
	private Date createdDateTime;
	
	@Column(name = "modifiedDateTime")
	@Temporal(TemporalType.TIMESTAMP)
	private Date modifiedDateTime;

	@Column(name = "createdBy")	
	private String createdBy;
	
	@Column(name = "modifiedBy")	
	private String modifiedBy;

	
	
	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Integer getSchoolId() {
		return schoolId;
	}

	public void setSchoolId(Integer schoolId) {
		this.schoolId = schoolId;
	}

	public String getClassName() {
		return className;
	}

	public void setClassName(String className) {
		this.className = className;
	}

	public String getSubject() {
		return subject;
	}

	public void setSubject(String subject) {
		this.subject = subject;
	}

	public Integer getTeacherId() {
		return teacherId;
	}

	public void setTeacherId(Integer teacherId) {
		this.teacherId = teacherId;
	}

	public String getMeetingNumber() {
		return meetingNumber;
	}

	public void setMeetingNumber(String meetingNumber) {
		this.meetingNumber = meetingNumber;
	}

	public String getMeetingPassword() {
		return meetingPassword;
	}

	public void setMeetingPassword(String meetingPassword) {
		this.meetingPassword = meetingPassword;
	}

	public Date getStartTime() {
		return startTime;
	}

	public void setStartTime(Date startTime) {
		this.startTime = startTime;
	}

	public Integer getDuration() {
		return duration;
	}

	public void setDuration(Integer duration) {
		this.duration = duration;
	}

	public Integer getSendNotification() {
		return sendNotification;
	}

	public void setSendNotification(Integer sendNotification) {
		this.sendNotification = sendNotification;
	}

	public String getNote() {
		return note;
	}

	public void setNote(String note) {
		this.note = note;
	}

	public Integer getStatus() {
		return status;
	}

	public void setStatus(Integer status) {
		this.status = status;
	}

	public Date getCreatedDateTime() {
		return createdDateTime;
	}

	public void setCreatedDateTime(Date createdDateTime) {
		this.createdDateTime = createdDateTime;
	}

	public Date getModifiedDateTime() {
		return modifiedDateTime;
	}

	public void setModifiedDateTime(Date modifiedDateTime) {
		this.modifiedDateTime = modifiedDateTime;
	}

	public String getCreatedBy() {
		return createdBy;
	}

	public void setCreatedBy(String createdBy) {
		this.createdBy = createdBy;
	}

	public String getModifiedBy() {
		return modifiedBy;
	}

	public void setModifiedBy(String modifiedBy) {
		this.modifiedBy = modifiedBy;
	}
	

	
	
	
	
	
}
