package com.bizofficer.hibernate.entity;

import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Cacheable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;


@Entity
@Table(name = "subscription_courses")
@Cacheable
public class SubscriptionCourses {

	@Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
	private Integer courseId;

	@Column(name = "websiteId")	
	private Integer websiteId;
	
	@Column(name = "webUrl")	
	private String webUrl;
	
	@Column(name = "categoryId")	
	private Integer categoryId;
	
	@Column(name = "categoryName")	
	private String categoryName;
	
	@Column(name = "freeOrganisationId")	
	private Integer freeOrganisationId;
	
	@Column(name = "freeOrganisationName")	
	private String freeOrganisationName;
	
	@Column(name = "paidOrganisationId")	
	private Integer paidOrganisationId;
	
	@Column(name = "paidOrganisationName")	
	private String paidOrganisationName;

	@Column(name = "courseUrl")	
	private String courseUrl;
	
	@Column(name = "courseTitle")	
	private String courseTitle;
	
	@Column(name = "courseSubTitle")	
	private String courseSubTitle;
	
	@Column(name = "headingDescription")	
	private String headingDescription;

	@Column(name = "courseImage")	
	private String courseImage;
	
	@Column(name = "courseBannerImage")	
	private String courseBannerImage;
	
	@Column(name = "retailPrice")	
	private BigDecimal retailPrice;
	
	@Column(name = "salePrice")	
	private BigDecimal salePrice;
	
	@Column(name = "discount")	
	private Integer discount;

	@Column(name = "validityNumber")	
	private Integer validityNumber;
	
	@Column(name = "validityUnit")	
	private String validityUnit;
	
	@Column(name = "validityDate")
	@Temporal(TemporalType.TIMESTAMP)
	private Date validityDate;

	@Column(name = "level")	
	private String level;
	
	@Column(name = "tags")	
	private String tags;

	@Column(name = "topics")	
	private String topics;
	
	@Column(name = "keywords")	
	private String keywords;

	@Column(name = "searchTxt")	
	private String searchTxt;

	@Column(name = "courseDetail")	
	private String courseDetail;
	
	@Column(name = "courseDetailMobile")	
	private String courseDetailMobile;

	@Column(name = "metaTags")	
	private String metaTags;
	
	@Column(name = "rating")	
	private Integer rating;

	@Column(name = "numberOfReview")	
	private Integer numberOfReview;
	
	@Column(name = "displayHome")	
	private Integer displayHome;
	
	@Column(name = "status")	
	private Integer status;
	
	@Column(name = "createdDateTime")
	@Temporal(TemporalType.TIMESTAMP)
	private Date createdDateTime;

	@Column(name = "createdBy")	
	private String createdBy;
	
	@Column(name = "modifiedDateTime")
	@Temporal(TemporalType.TIMESTAMP)
	private Date modifiedDateTime;

	@Column(name = "modifiedBy")	
	private String modifiedBy;

	public Integer getCourseId() {
		return courseId;
	}

	public void setCourseId(Integer courseId) {
		this.courseId = courseId;
	}

	public Integer getWebsiteId() {
		return websiteId;
	}

	public void setWebsiteId(Integer websiteId) {
		this.websiteId = websiteId;
	}

	public Integer getCategoryId() {
		return categoryId;
	}

	public void setCategoryId(Integer categoryId) {
		this.categoryId = categoryId;
	}

	public String getCategoryName() {
		return categoryName;
	}

	public void setCategoryName(String categoryName) {
		this.categoryName = categoryName;
	}

	public String getCourseUrl() {
		return courseUrl;
	}

	public void setCourseUrl(String courseUrl) {
		this.courseUrl = courseUrl;
	}

	public String getCourseTitle() {
		return courseTitle;
	}

	public void setCourseTitle(String courseTitle) {
		this.courseTitle = courseTitle;
	}

	public String getCourseSubTitle() {
		return courseSubTitle;
	}

	public void setCourseSubTitle(String courseSubTitle) {
		this.courseSubTitle = courseSubTitle;
	}

	public String getHeadingDescription() {
		return headingDescription;
	}

	public void setHeadingDescription(String headingDescription) {
		this.headingDescription = headingDescription;
	}

	public String getCourseImage() {
		return courseImage;
	}

	public void setCourseImage(String courseImage) {
		this.courseImage = courseImage;
	}

	public String getCourseBannerImage() {
		return courseBannerImage;
	}

	public void setCourseBannerImage(String courseBannerImage) {
		this.courseBannerImage = courseBannerImage;
	}

	public BigDecimal getRetailPrice() {
		return retailPrice;
	}

	public void setRetailPrice(BigDecimal retailPrice) {
		this.retailPrice = retailPrice;
	}

	public BigDecimal getSalePrice() {
		return salePrice;
	}

	public void setSalePrice(BigDecimal salePrice) {
		this.salePrice = salePrice;
	}

	public Integer getDiscount() {
		return discount;
	}

	public void setDiscount(Integer discount) {
		this.discount = discount;
	}

	public Integer getValidityNumber() {
		return validityNumber;
	}

	public void setValidityNumber(Integer validityNumber) {
		this.validityNumber = validityNumber;
	}

	public String getValidityUnit() {
		return validityUnit;
	}

	public void setValidityUnit(String validityUnit) {
		this.validityUnit = validityUnit;
	}

	public String getLevel() {
		return level;
	}

	public void setLevel(String level) {
		this.level = level;
	}

	public String getTags() {
		return tags;
	}

	public void setTags(String tags) {
		this.tags = tags;
	}

	public String getTopics() {
		return topics;
	}

	public void setTopics(String topics) {
		this.topics = topics;
	}

	public String getKeywords() {
		return keywords;
	}

	public void setKeywords(String keywords) {
		this.keywords = keywords;
	}

	public String getSearchTxt() {
		return searchTxt;
	}

	public void setSearchTxt(String searchTxt) {
		this.searchTxt = searchTxt;
	}

	public String getCourseDetail() {
		return courseDetail;
	}

	public void setCourseDetail(String courseDetail) {
		this.courseDetail = courseDetail;
	}

	public String getMetaTags() {
		return metaTags;
	}

	public void setMetaTags(String metaTags) {
		this.metaTags = metaTags;
	}

	public Integer getRating() {
		return rating;
	}

	public void setRating(Integer rating) {
		this.rating = rating;
	}

	public Integer getNumberOfReview() {
		return numberOfReview;
	}

	public void setNumberOfReview(Integer numberOfReview) {
		this.numberOfReview = numberOfReview;
	}

	public Integer getDisplayHome() {
		return displayHome;
	}

	public void setDisplayHome(Integer displayHome) {
		this.displayHome = displayHome;
	}

	public Integer getStatus() {
		return status;
	}

	public void setStatus(Integer status) {
		this.status = status;
	}

	public Date getCreatedDateTime() {
		return createdDateTime;
	}

	public void setCreatedDateTime(Date createdDateTime) {
		this.createdDateTime = createdDateTime;
	}

	public String getCreatedBy() {
		return createdBy;
	}

	public void setCreatedBy(String createdBy) {
		this.createdBy = createdBy;
	}

	public Date getModifiedDateTime() {
		return modifiedDateTime;
	}

	public void setModifiedDateTime(Date modifiedDateTime) {
		this.modifiedDateTime = modifiedDateTime;
	}

	public String getModifiedBy() {
		return modifiedBy;
	}

	public void setModifiedBy(String modifiedBy) {
		this.modifiedBy = modifiedBy;
	}

	public String getCourseDetailMobile() {
		return courseDetailMobile;
	}

	public void setCourseDetailMobile(String courseDetailMobile) {
		this.courseDetailMobile = courseDetailMobile;
	}

	public String getWebUrl() {
		return webUrl;
	}

	public void setWebUrl(String webUrl) {
		this.webUrl = webUrl;
	}

	public Integer getFreeOrganisationId() {
		return freeOrganisationId;
	}

	public void setFreeOrganisationId(Integer freeOrganisationId) {
		this.freeOrganisationId = freeOrganisationId;
	}

	public String getFreeOrganisationName() {
		return freeOrganisationName;
	}

	public void setFreeOrganisationName(String freeOrganisationName) {
		this.freeOrganisationName = freeOrganisationName;
	}

	public Integer getPaidOrganisationId() {
		return paidOrganisationId;
	}

	public void setPaidOrganisationId(Integer paidOrganisationId) {
		this.paidOrganisationId = paidOrganisationId;
	}

	public String getPaidOrganisationName() {
		return paidOrganisationName;
	}

	public void setPaidOrganisationName(String paidOrganisationName) {
		this.paidOrganisationName = paidOrganisationName;
	}

	public Date getValidityDate() {
		return validityDate;
	}

	public void setValidityDate(Date validityDate) {
		this.validityDate = validityDate;
	}
	

	
	

	
	

	



	


	
	
	
	

	
	
}
