package com.bizofficer.hibernate.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.bizofficer.hibernate.entity.PgprepAdministrator;


@Repository
public interface PgprepAdministratorRepository extends JpaRepository<PgprepAdministrator, Long> {

	PgprepAdministrator findByEmailIdAndLoginToken(String emailId, String loginToken);
	
	PgprepAdministrator findByEmailId(String emailId);
	
	@Transactional
	@Modifying
	@Query(value = "UPDATE PgprepAdministrator SET roleName=:roleName,privileges=:privileges where roleId=:roleId")
	void updateRoleName(@Param("roleId") Integer roleId, @Param("roleName") String roleName, @Param("privileges") String privileges);
	
	@Transactional
	@Modifying
	void deleteById(Integer id);
	
}
