package com.bizofficer.hibernate.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.bizofficer.hibernate.entity.PgprepSchoolUsers;

@Repository
public interface PgprepSchoolUsersRepository extends JpaRepository<PgprepSchoolUsers, Long> {

	PgprepSchoolUsers findByEmailIdAndLoginToken(String emailId, String loginToken);
	
	PgprepSchoolUsers findIdByEmailId(String emailId);
	
	PgprepSchoolUsers findIdByEmailIdAndIdNot(String emailId, Integer id);
	
	@Modifying
	@Transactional
    @Query("Update PgprepSchoolUsers SET schoolName=:schoolName WHERE schoolId=:schoolId")
    void updateSchoolName(@Param("schoolName") String schoolName, @Param("schoolId") Integer schoolId);
	
	@Transactional
	@Modifying
	void deleteById(Integer id);
	
	@Transactional
	@Modifying
	void deleteBySchoolId(Integer schoolId);
	
}
