package com.bizofficer.school.subjects;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.entity.PgprepSubjects;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;


@Service
public class SubjectService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository adminRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		SubjectBean objBean = (SubjectBean) obj;
		List<SubjectResponseBean> responseListObj = new ArrayList<SubjectResponseBean>();
		
		try {
			
			System.out.println("ClassesService EmailId >> " + objBean.getEmailId() );
			System.out.println("ClassesService Token >> " + objBean.getToken() );
			System.out.println("ClassesService Keyword >> " + objBean.getKeyword() );
			
			if(objBean.getEmailId()==null || objBean.getToken()==null) {
				return responseListObj;
			}
			
			PgprepSchoolUsers adminObj = (PgprepSchoolUsers) adminRepo.findByEmailIdAndLoginToken(objBean.getEmailId(), objBean.getToken());
			System.out.println("Verify >> " + adminObj.getId() );
			
			if(adminObj.getId()==null) {
				return responseListObj;
			}
			
			System.out.println("*********************Teachers******************************");
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			String whereQry =" WHERE 1=1 ";				
			if(objBean.getKeyword()!=null && objBean.getKeyword().length()>0 ) {
				whereQry +=" AND (subject LIKE :keyword) ";
			}
			TypedQuery<PgprepSubjects> query = (TypedQuery<PgprepSubjects>) entityManager.createQuery("from "+PgprepSubjects.class.getName()+whereQry+" order by subject ", PgprepSubjects.class);
			if(objBean.getKeyword()!=null && objBean.getKeyword().length()>0 ) {
				query.setParameter("keyword", "%"+objBean.getKeyword()+"%");
			}
			query.setFirstResult(0);
			query.setMaxResults(500);
			List<?> resultList = query.getResultList();
			System.out.println("Subjects resultList Count: "+resultList.size());
			Iterator<?> iterator=resultList.iterator();	
			SubjectResponseBean responseBeanObj;
			while(iterator.hasNext()){
				PgprepSubjects myObj = (PgprepSubjects)iterator.next();		
				
				responseBeanObj = new SubjectResponseBean();
				responseBeanObj.setId(myObj.getId());
				responseBeanObj.setSubject(myObj.getSubject());
				
				responseListObj.add(responseBeanObj);
			}

			System.out.println("Subjects Count: "+responseListObj.size());
				
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseListObj;
	}
	

	
	

	
	
}
