package com.bizofficer.school.teachers;



import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepSchoolUsers;
import com.bizofficer.hibernate.entity.PgprepTeachers;
import com.bizofficer.hibernate.repository.PgprepSchoolUsersRepository;
import com.bizofficer.system.util.General;


@Service
public class TeachUpdateService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepSchoolUsersRepository adminRepo;
	
	public Object execute(Object obj) throws NotFoundException{
		TeachBean objBean = (TeachBean) obj;
		TeachSaveResponseBean responseListObj = new TeachSaveResponseBean();
		
		try {
			
			System.out.println("TeachUpdateService LoginEmailId >> " + objBean.getLoginEmailId() );
			System.out.println("TeachUpdateService Token >> " + objBean.getToken() );
			System.out.println("TeachUpdateService SchoolName >> " + objBean.getSchoolName() );
			System.out.println("TeachUpdateService SchoolId >> " + objBean.getSchoolId() );
			System.out.println("TeachUpdateService LoginId >> " + objBean.getLoginId() );
			System.out.println("TeachUpdateService EmailId >> " + objBean.getEmailId() );
			System.out.println("TeachUpdateService TeacherName >> " + objBean.getTeacherName() );			
			System.out.println("TeachUpdateService AccountStatus >> " + objBean.getAccountStatus() );
			System.out.println("TeachUpdateService Role >> " + objBean.getRole() );
			
			if(objBean.getLoginEmailId()==null || objBean.getToken()==null) {
				return responseListObj;
			}
			
			PgprepSchoolUsers adminObj = (PgprepSchoolUsers) adminRepo.findByEmailIdAndLoginToken(objBean.getLoginEmailId(), objBean.getToken());
			System.out.println("Verify >> " + adminObj.getId() );
			
			if(adminObj.getId()==null) {
				return responseListObj;
			}
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			General gen = new General();
			
			PgprepTeachers findObj = (PgprepTeachers)entityManager.find(PgprepTeachers.class ,objBean.getId());
			findObj.setEmailId(objBean.getEmailId());
			findObj.setTeacherName(objBean.getTeacherName());
				
			if(objBean.getNewPassword()!=null && objBean.getNewPassword().length()>2 ) {
				findObj.setPassword(gen.getMD5Hashing(objBean.getNewPassword()));
			}

			if(Boolean.TRUE.equals(objBean.getAccountStatusChk())) {
				findObj.setAccountStatus(1);
			}else {
				findObj.setAccountStatus(0);
			}

			responseListObj.setResponseTxt("OK");			
			
			entityManager.getTransaction().commit();
			entityManager.close();
		        
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return responseListObj;
	}
	

	
	

	
	
}
