package com.bizofficer.school.teachers;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.bizofficer.school.classes.ClassesBean;
import com.bizofficer.school.classes.ClassesResponseBean;
import com.bizofficer.school.classes.ClassesService;
import com.bizofficer.school.subjects.SubjectBean;
import com.bizofficer.school.subjects.SubjectResponseBean;
import com.bizofficer.school.subjects.SubjectService;

@RestController
@Service
public class TeacherAssociationController {
	
	@Autowired
	private TeacherAssociationService serviceObj;
	
	@Autowired
	private ClassesService classesServiceObj;
	
	@Autowired
	private TeachService teacherServiceObj;
	
	@Autowired
	private SubjectService subjectServiceObj;
	
	@RequestMapping(value = {"/teacherassociation"}, method = {RequestMethod.GET})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")TeachBean objBean) {
		
		try {
			
			TeacherAssociationResponseBean tsrbObj = (TeacherAssociationResponseBean) (Object) serviceObj.execute(objBean);

			@SuppressWarnings("unchecked")
			List<TeachResponseBean> teacherObj = (List<TeachResponseBean>) (Object) teacherServiceObj.execute(objBean);
			tsrbObj.setTeachers(teacherObj);
			
			ClassesBean clsBean = new ClassesBean();
			clsBean.setEmailId(objBean.getEmailId());
			clsBean.setToken(objBean.getToken());
			@SuppressWarnings("unchecked")
			List<ClassesResponseBean> classesObj = (List<ClassesResponseBean>) (Object) classesServiceObj.execute(clsBean);
			tsrbObj.setClasses(classesObj);
			
			SubjectBean subjectBean = new SubjectBean();
			subjectBean.setEmailId(objBean.getEmailId());
			subjectBean.setToken(objBean.getToken());
			@SuppressWarnings("unchecked")
			List<SubjectResponseBean> subjectObj = (List<SubjectResponseBean>) (Object) subjectServiceObj.execute(subjectBean);
			tsrbObj.setSubjects(subjectObj);
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
