package com.bizofficer.subscription.courses;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.SubscriptionCoursesCategory;


@Service
public class CoursesCategoryService{
	
    @Autowired
	EntityManagerFactory entityManagerFactory;
	
	public List<?> execute(Object obj) throws NotFoundException{
		ACoursesBean objBean = (ACoursesBean) obj; 	
		List<CoursesCategoryResponseBean> dataList = new ArrayList<CoursesCategoryResponseBean>();
		
		try {
			
			if(objBean.getWebsiteId()==null) {
				return dataList;
			}
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();

			CoursesCategoryResponseBean coursesResObj = new CoursesCategoryResponseBean();
			
			TypedQuery<SubscriptionCoursesCategory> queryCat = (TypedQuery<SubscriptionCoursesCategory>) entityManager.createQuery("from "+SubscriptionCoursesCategory.class.getName()+" WHERE status=1 AND websiteId=:websiteId order by orderBy ", SubscriptionCoursesCategory.class);
			queryCat.setParameter("websiteId", objBean.getWebsiteId() );
			List<?> resultListCat = queryCat.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();
			while(iteratorCat.hasNext()){
				SubscriptionCoursesCategory myObj = (SubscriptionCoursesCategory)iteratorCat.next();
				
				coursesResObj = new CoursesCategoryResponseBean();
				coursesResObj.setCategoryId(myObj.getCategoryId());
				coursesResObj.setCategoryName(myObj.getCategoryName());
				coursesResObj.setShortDescription(myObj.getShortDescription());
				
				dataList.add(coursesResObj);
				
			}	
           
                        
            entityManager.getTransaction().commit();
			entityManager.close();
			
		}catch(Exception e) {
			e.getStackTrace();			
		}
		
		
		return dataList;
	}
	
	
	
	
}
