package com.bizofficer.subscription.registration;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Service
public class AddCourseToMyAccountController {
	
	private static final Logger logger = Logger.getLogger(AddCourseToMyAccountController.class);
	
	@Autowired
	private AddCourseToMyAccountRegistrationService serviceObj;
	
	@RequestMapping(value = {"/mobile-addcousetomyaccount"}, method = {RequestMethod.POST})
	public ResponseEntity<Object> execute(@ModelAttribute("SpringWeb")AaRegBean objBean) {
		
		try {
			
			logger.info("Token: "+objBean.getToken() );
			logger.info("CourseId: "+objBean.getCourseId() );
			
			RegistrationResponseBean tsrbObj = (RegistrationResponseBean) (Object) serviceObj.execute(objBean);
			
			logger.info("ResponseTxt: "+tsrbObj.getResponseTxt());
			
			HttpHeaders headers = new HttpHeaders();
	        ////headers.add("Responded", "UserController");
	        return ResponseEntity.ok().headers(headers).body(tsrbObj);
			
		} catch (Exception e) {
			e.printStackTrace();
			/////return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).body(e);
		}
		
		return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
	}
	

	
	
}
