package com.bizofficer.teacher.forgotpassword;



import javax.sql.DataSource;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.module.util.MysqlTableNames;
import com.bizofficer.system.util.General;
import com.bizofficer.system.util.SendGridMail;

import java.io.FileReader;
import java.net.URL;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.UUID;


@Service
public class FPTeachService{
	
	@Autowired
    DataSource appDataSource;
    Connection conn;
    PreparedStatement ps;
    ResultSet rs;
	
	public Object execute(Object obj) throws NotFoundException{
		FPTeachBean objBean = (FPTeachBean) obj; 	
		FPTeachResponseBean loginResponseBeanObj = new FPTeachResponseBean();
		
		try {
			loginResponseBeanObj.setResponseTxt("failed");
			
			if(objBean.getEmailId()==null) {
				return loginResponseBeanObj;
			}

			System.out.println("Forgot Password Service EmailId: "+objBean.getEmailId() );
			
	            this.conn = this.appDataSource.getConnection();
	            if (this.conn != null) {
	                this.ps = this.conn.prepareStatement("SELECT id FROM "+MysqlTableNames.getPgprepTeachers()+" WHERE emailId=? AND accountStatus=1");
	                this.ps.setString(1, objBean.getEmailId());
	                System.out.println("Forgot Password Service query: " + this.ps);
	                this.rs = this.ps.executeQuery();
	                if (this.rs.next()) {
	
	                	String resetPasswordCode = UUID.randomUUID().toString().replaceAll("-", "");
	                	
	                	PreparedStatement psA = conn.prepareStatement("UPDATE "+MysqlTableNames.getPgprepTeachers()+" SET resetPasswordToken='"+resetPasswordCode+"' WHERE emailId='"+objBean.getEmailId()+"' AND accountStatus=1 ");
	                    psA.executeUpdate();
	                    
	                    ///objBean.setEmailId("ramesh.piwania@gmail.com");
	                    
	                    General gen = new General();
	                    SendGridMail mailObj = new SendGridMail();				
						String[] emailsToArr = {objBean.getEmailId()};
						
						URL url = this.getClass().getResource("/resetpassword-emailteacher.json");
						String absoluteDiskPath = url.getPath();
						JSONParser jsonParser = new JSONParser();
						FileReader reader = new FileReader(absoluteDiskPath);
						Object objJson = jsonParser.parse(reader);	
						JSONObject json = (JSONObject) objJson;
						String subject = (String) json.get("subject")+"........."+gen.getRandomNumber(99, 9999);
						String messageBody = (String) json.get("message");
						
						//System.out.println("subject >>>> " + subject);
						//System.out.println("messageBody >>>> " + messageBody);
						
						messageBody = messageBody.replace("[TOKEN]", resetPasswordCode );
								
						System.out.println("Mail Status: " + mailObj.send(emailsToArr, null, subject, messageBody));
	                	
	                    loginResponseBeanObj.setResponseTxt("OK");
	                    
	    				System.out.println("**************************************************************");
	    				System.out.println("Token: "+resetPasswordCode);
	    				System.out.println("Successfully Forgot Password Service EmailId: "+objBean.getEmailId());
	    				System.out.println("**************************************************************");
	                    
	                }else {
	                	loginResponseBeanObj.setResponseTxt("InvalidEmailId");
	                }
	                
	                this.rs.close();
	                this.ps.close();
	                this.conn.close();
            }

		}catch(Exception e) {
			e.getStackTrace();
		}
		
		
		return loginResponseBeanObj;
	}
	
	
	
	
}
