package com.bizofficer.teacher.schedule;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.hibernate.entity.PgprepScheduleClassTest;
import com.bizofficer.system.util.MakeDate;


@Service
public class ScheduleService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	public List<?> doExecute(Object obj) throws NotFoundException{
		BeanSchedule objBean = (BeanSchedule) obj; 	
		List<ScheduleResponseBean> dataList = new ArrayList<ScheduleResponseBean>();
		
		try {
			
			System.out.println( "ScheduleService schoolId >>> " +  objBean.getSchoolId() );
			System.out.println( "ScheduleService LoginId >>> " +  objBean.getLoginId() );
		
			if(objBean.getSchoolId()==null || objBean.getLoginId()==null) {
				return dataList;
			}
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			ScheduleResponseBean serviceObj;
			MakeDate mkdate = new MakeDate();

//			List<String> classList = Arrays.asList(objBean.getClassList().split(","));
//			List<String> subjectList = Arrays.asList(objBean.getSubjectList().split(","));
			
			TypedQuery<PgprepScheduleClassTest> query = (TypedQuery<PgprepScheduleClassTest>) entityManager.createQuery("from "+PgprepScheduleClassTest.class.getName()+" where date(testDateTime)>=CURDATE() AND schoolId=?1 AND createdById=?2 order by id desc ", PgprepScheduleClassTest.class);
			query.setParameter(1, objBean.getSchoolId());
			query.setParameter(2, objBean.getLoginId());
			List<?> resultListCat = query.getResultList();
			Iterator<?> iteratorCat=resultListCat.iterator();
			int i=1;
			while(iteratorCat.hasNext()){
				PgprepScheduleClassTest myObj = (PgprepScheduleClassTest)iteratorCat.next();
				
				serviceObj = new ScheduleResponseBean();
				serviceObj.setId(i);
				serviceObj.setAutoId(myObj.getId());
				serviceObj.setScheduleId(myObj.getScheduleId());
				serviceObj.setTestTitle(myObj.getTestTitle());
				serviceObj.setQuestionType(myObj.getQuestionType());
				serviceObj.setClassName(myObj.getClassName());
				serviceObj.setTopicId(0);
				serviceObj.setSubject(myObj.getSubject());
								
				if(myObj.getTestDateTime()!=null) {
					serviceObj.setTestDateTime(mkdate.changeDateTimeFormat(myObj.getTestDateTime(), "yyyy-MM-dd HH:mm:ss"));
				}
				
				serviceObj.setTopicTestId(myObj.getTopicTestId());
				serviceObj.setTotalQuestion(myObj.getTotalQuestion());
				serviceObj.setTotalTime(myObj.getTotalTime());
				serviceObj.setTotalMark(myObj.getTotalMark());
				serviceObj.setMarkCorrectAns(myObj.getMarkCorrectAns());
				serviceObj.setMarkIncorrectAns(myObj.getMarkIncorrectAns());
				serviceObj.setMarkNotAttempt(myObj.getMarkNotAttempt());
				serviceObj.setCreatedById(myObj.getCreatedById());
				
				dataList.add(serviceObj);
				i++;
				
			}
			entityManager.getTransaction().commit();
			entityManager.close();
			
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		///System.out.println( "dataList >>> " +  dataList );
			
		return dataList;
	}
	
	
	
}
