package com.bizofficer.teacher.scheduleliveclass;

import java.util.Iterator;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.TypedQuery;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.crossstore.ChangeSetPersister.NotFoundException;
import org.springframework.stereotype.Service;

import com.bizofficer.api.zoom.AZoomMeetingUtils;
import com.bizofficer.api.zoom.ZoomBean;
import com.bizofficer.api.zoom.ZoomMeetingObjectDTO;
import com.bizofficer.hibernate.entity.PgprepLiveClasses;
import com.bizofficer.hibernate.entity.PgprepTeachers;
import com.bizofficer.hibernate.repository.PgprepLiveClassesRepository;
import com.bizofficer.hibernate.repository.PgprepTeachersRepository;
import com.bizofficer.system.util.MakeDate;


@Service
public class SaveLiveClassTeachService{
	
	@Autowired
	EntityManagerFactory entityManagerFactory;
	
	@Autowired
	PgprepTeachersRepository teachRepo;
	
	@Autowired
	PgprepLiveClassesRepository plcRepo;
	
	@Autowired
	private AZoomMeetingUtils azmuObj;
	
	public Object doExecute(Object obj) throws NotFoundException{
		BeanLiveClassTeach objBean = (BeanLiveClassTeach) obj; 	
		LiveClassTeachResponseBean responseObj = new LiveClassTeachResponseBean();
		
		try {
		
			responseObj.setResponseTxt("failed");

			System.out.println("SaveLiveClassService Id: "+objBean.getId());
			System.out.println("SaveLiveClassService Token: "+objBean.getToken());
			System.out.println("SaveLiveClassService SchoolId: "+objBean.getSchoolId());
			System.out.println("SaveLiveClassService Teacher Login Id: "+objBean.getLoginId());
			System.out.println("SaveLiveClassService Duration: "+objBean.getDuration());
			System.out.println("SaveLiveClassService Status: "+objBean.getStatus());
			System.out.println("SaveLiveClassService Class Name: "+objBean.getClassName());
			System.out.println("SaveLiveClassService Subject: "+objBean.getSubject());
			System.out.println("SaveLiveClassService Start Time: "+objBean.getStartTime());
			System.out.println("SaveLiveClassService Note: "+objBean.getNote());
			
			if(objBean.getSchoolId()==null || objBean.getLoginId()==null || objBean.getToken()==null) {
				return responseObj;
			}
			
			PgprepTeachers teachObj = (PgprepTeachers) teachRepo.getIdBySchoolIdAndLoginIdAndLoginToken(objBean.getSchoolId(), objBean.getLoginId(), objBean.getToken());
			if(teachObj==null) {
				return responseObj;
			}

			System.out.println("Verified ID: " + teachObj.getId() );
			System.out.println("School ID: " + teachObj.getSchoolId() );
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			entityManager.getTransaction().begin();
			
			MakeDate mkdate = new MakeDate();
			
			String whereSql="";
			if(objBean.getId()!=null && objBean.getId()>0) {
				whereSql=" AND id!=:id ";
			}
			
			///CHECK MULTIPLE LIVE CLASS CAN BE SET AT SAME DATE AND TIME
			TypedQuery<PgprepLiveClasses> querySCT = (TypedQuery<PgprepLiveClasses>) entityManager.createQuery("from "+PgprepLiveClasses.class.getName()+" where schoolId=:schoolId AND teacherId=:teacherId AND className=:className AND subject=:subject AND startTime=:startTime "+whereSql, PgprepLiveClasses.class);
			querySCT.setParameter("schoolId", teachObj.getSchoolId());
			querySCT.setParameter("teacherId", teachObj.getId());
			querySCT.setParameter("className", objBean.getClassName());
			querySCT.setParameter("subject", objBean.getSubject());
			querySCT.setParameter("startTime", mkdate.getStringToDate(objBean.getStartTime(), "yyyy-MM-dd HH:mm:ss"));
			if(objBean.getId()!=null && objBean.getId()>0) {
				querySCT.setParameter("id", objBean.getId());
			}
			querySCT.setFirstResult(0);
			querySCT.setMaxResults(1);
			List<?> resultListSCT = querySCT.getResultList();
			Iterator<?> iteratorSCT=resultListSCT.iterator();
			if(iteratorSCT.hasNext()) {
				
				responseObj.setResponseTxt("AlreadyExistsError");
				System.out.println("**************************************************************");
				System.out.println("SaveLiveClassService AlreadyExistsError");
				System.out.println("SaveLiveClassService Teacher Id: "+objBean.getLoginId());
				System.out.println("**************************************************************");

			}else{
			
				Integer autoTestId = 0; 
				PgprepLiveClasses saveObj = null;
				if(objBean.getId()!=null && objBean.getId()>0) {
					saveObj = (PgprepLiveClasses)entityManager.find(PgprepLiveClasses.class ,objBean.getId());
					saveObj.setModifiedDateTime(mkdate.getCurrentTimeStamp());
					saveObj.setModifiedBy(objBean.getLoginId());
				}else {
					saveObj = new PgprepLiveClasses();
					saveObj.setSchoolId(objBean.getSchoolId());
					saveObj.setCreatedDateTime(mkdate.getCurrentTimeStamp());
					saveObj.setCreatedBy(objBean.getLoginId());
					saveObj.setModifiedDateTime(mkdate.getCurrentTimeStamp());
					saveObj.setModifiedBy(objBean.getLoginId());
				}

				
				//CREATE ZOOM MEETING	
				if(objBean.getStartTime()!=null && objBean.getStartTime().length()>5) {
					ZoomBean zmBean = new ZoomBean();
					zmBean.setAgenda(objBean.getSubject()+" "+objBean.getClassName());
					zmBean.setStartTime(mkdate.getStringToDate(objBean.getStartTime(), "yyyy-MM-dd HH:mm:ss"));
					zmBean.setDuration(objBean.getDuration());
					ZoomMeetingObjectDTO dtoObj = (ZoomMeetingObjectDTO) (Object) azmuObj.createMeeting(zmBean);
					saveObj.setMeetingNumber(String.valueOf(dtoObj.getId()));					
					saveObj.setMeetingPassword(dtoObj.getPassword());
				}
				
				
				saveObj.setClassName(objBean.getClassName());
				saveObj.setSubject(objBean.getSubject());					
				saveObj.setTeacherId(teachObj.getId());

				saveObj.setDuration(objBean.getDuration());
				saveObj.setNote(objBean.getNote());
				saveObj.setStatus(objBean.getStatus());
				
				if(objBean.getStartTime()!=null && objBean.getStartTime().length()>5) {
					saveObj.setStartTime(mkdate.getStringToDate(objBean.getStartTime(), "yyyy-MM-dd HH:mm:ss"));
				}
				
				if(objBean.getId()!=null && objBean.getId()>0) {
					entityManager.getTransaction().commit();
					autoTestId = objBean.getId();
				}else {
					PgprepLiveClasses resultObj = plcRepo.save(saveObj);
					autoTestId = resultObj.getId();
				}
			
				if(autoTestId!=null && autoTestId>0 && saveObj.getMeetingNumber()!=null && saveObj.getMeetingNumber().length()>2 ){
					responseObj.setResponseTxt("success");
					System.out.println("**************************************************************");
					System.out.println("SaveLiveClassService Successfully Teacher Login Id: "+objBean.getLoginId());
					System.out.println("**************************************************************");
				}
				
			}	
			
			entityManager.getTransaction().commit();
			entityManager.close();
			
			
		}catch(Exception e) {
			e.getStackTrace();
		}
		
		///System.out.println( "dataList >>> " +  dataList );
			
		return responseObj;
	}
	
	

	
}
